///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <string.h>

#include "rdrtime.hpp"
#include "download.hpp"

RdRtime *dwl=NULL;

void main(int argc, char *argv[])
{
	short  error=TRANS_OK;
	double curr_percent;
	char 	 rawdatafile_name[13];

	if (argc<2) return;
	
	dwl = new RdRtime();
  if (dwl==NULL) return;

	if (argc==3) strcpy(dwl->pathDataFile,argv[2]);
	// ***********************************  Initialization ******************************************
	strcpy(rawdatafile_name,argv[1]);
	if ((rawdatafile_name[0]=='R')||(rawdatafile_name[0]=='r'))
	{	error=dwl->ReceiverInfofromDumpMemory(rawdatafile_name);
		if (error!=TRANS_OK) { dwl->CloseDumpMemoryFile(); CloseDownload(); return; }
		Init_f_createFile();
		Init_f_writeFile();
		dwl->Set_type_analyse(ANSHEAD);
		error=dwl->AnalysReadfRec(); //analysis head.file and SendRdfromRec()!!! 
		if (error==COLLECTING_DATA) error=TRANS_OK;
		if (error==TRANS_OK)
		{ dwl->FormSfile();
			Write_file_trans();
		}
		else
		{ dwl->CloseDumpMemoryFile(); 
			CloseDownload(); 
			return; 
		}	
	}
	else
	{	dwl->rid_options[0]='\0';
		error=dwl->ans_FileDirCountMZ(rawdatafile_name);
		if (error!=TRANS_OK) { CloseDownload(); return; }
		// Emulation $PASHQ,RID for MicroZ
		strcpy((char *)dwl->bf.ibf,"$PASHR,RID,UZ,30,U122,BUEXM-T3J,0A12*5A\r\n\0");
		dwl->bf.tbf[0]=dwl->bf.ibf[0];
		dwl->ansReceiverInfo(41); 
		dwl->Init_almanac_strct();
		// ******************************** for S-file Initialization ************************************
		dwl->InitHeadYFile();
		// ************************************* Download files ******************************************
		dwl->InitDownloadData();
		dwl->rawsession_bytes=0L;
		dwl->setCountPercent(0.0);
		Init_f_createFile();
		dwl->InitforReadVWfile();
	}
	dwl->InitSNV_parameters();

	for (;;) // U-file or R-file converting
	{	if (dwl->rec_type_code<G_XII)
		{	Init_f_writeFile();
			if (dwl->fwf.f_writeheaderCfile==0)
				error=dwl->AnalysReadfRec(); // read data and SendRdfromRec()!!!   
			else
			{ RewriteHeaderCfile();
				error=TRANS_OK;           
			}  
			Write_file_trans();
			if (dwl->fwf.f_writeheaderCfile==0)
			{ if ((error==TRANS_OK)&&(dwl->Get_curr_file_type()==RANGER_MODE2))
				{ dwl->fwf.f_writeheaderCfile=1; // only herein !!!
					error=COLLECTING_DATA;         
				}
			}    
			if ((error>=ERROR_MODEHOSE)||(error==TRANS_OK))
			{	dwl->CloseDumpMemoryFile();
				break;
			}
		}
		else
		{	if ((dwl->rawfile.V_file.name[0]=='U')||(dwl->rawfile.V_file.name[0]=='u'))
			{ if (dwl->f_fillbuf==0)
					error=dwl->ReadBlocksUfile((char *)dwl->rawfile.V_file.name);
				else
				{ Init_f_writeFile();
					if (dwl->f_fillbuf==3)
					{ error=dwl->AlmanacNameFile();
						if (error==NO_FILE) error=ERROR_RCI;
						if (error==TRANS_OK) Write_file_trans(true);
					}  
					else
					{ if (dwl->f_fillbuf==2)
						{ error=RewriteHeaderCfile();
							dwl->f_fillbuf=3;	
						}
						if (dwl->f_fillbuf==1)
						{ error=dwl->AnalysDataBlocks();
							if (dwl->f_fillbuf==0)
							error=dwl->EndReadFile(error);
						}
						Write_file_trans();
					}
				}  
			}
			else
				error=NO_FILE;

			if ((error>COLLECTING_DATA)&&(error<ERROR_RCI)&&(dwl->GetCurrbytesRawfiles()>8)&&(error!=ERROR_DATATYPE)) 
				error=ERROR_CHECKSUM; // no break cycled process !!!
			if ((error==COLLECTING_DATA)||(error==TRANS_OK)||(error==ERROR_CHECKSUM))	
			{ curr_percent=dwl->rawsession_bytes+dwl->GetCurrbytesRawfiles();
				curr_percent=100.0*curr_percent/dwl->rawfile.numbytes_session+0.5;
				if (curr_percent > 100.0) curr_percent=100.0;
				dwl->setCountPercent(curr_percent);
			}
			if ((error!=COLLECTING_DATA)&&(error!=ERROR_CHECKSUM))		
			{ dwl->CloseReadVWfile();
				break; 	
			}
		}
	}
	CloseDownload();
  return;
}


