///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <string.h>
#include <math.h>
#include <ctype.h>

#ifndef __RDRTIME_HPP
#include "rdrtime.hpp"
#endif

short RdRtime::AlmanacNameFile()
{{
  long   day_year,h,m,lsec,year=0L;
  long   month,mday;
  double sec;

  len_almanac=0;
  if (rtt.alm_wn>0) 
  { gps_to_ydhms(rtt.alm_wn,rtt.alm_tow,&year,&day_year,&h,&m,&sec);
    lsec=(long)(sec+0.5);
  }
  else
    rtf.f_wr_almGPS=0;
  if (year>0)
  { if (lsec>=60L) { m++; lsec -=60L; }
  	if (m>=60L)    { h++; m    -=60L; }
    month_and_day(year,day_year,&month,&mday);
    if (year>1900) year -=1900;
    if (year>=100) year -=100;
    sprintf((char *)file_rec.file_name,"alm%2.2ld.%3.3ld\0",year,day_year);  
    sprintf((char *)file_rec.date,"%2.2ld/%2.2ld/%2.2ld\0",month,mday,year);
    sprintf((char *)file_rec.time,"%2.2ld/%2.2ld/%2.2ld\0",h,m,lsec);
    sprintf((char *)file_rec.file_type,"ALMANAC \0");
    if (rtf.f_wr_almGPS)     len_almanac+=sizeof(almstrct)*32;
    sprintf((char *)file_rec.bytes,"%7ld\0",(long)len_almanac);
    return(TRANS_OK);
  }
  return(NO_FILE);
}}

