///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <string.h>
#include <math.h>
#include <stdlib.h>

#ifndef __RDRTIME_HPP
#include "rdrtime.hpp"
#endif

enum { SET_COM, ANS_COM };

RdRtime::RdRtime() : Trans()
{{
  rtf.real_time_mode=0;
  rec_type_code=UNKNOWN;
  rtt.difGMT=0.0;
	rtc.error_epoch=0L;
	fVWfile=NULL;
}}

short RdRtime::ansReceiverInfo(unsigned short numbytes)
{{
  short i;

  // -> com.cnbyte (\r\n) 
  // "$PASHR,RID,UZ,30,U122,BUEXM-T3J,0A12*5A\r\n\0" for MicroZ at work with disc only !!!
  // numbytes = 41
  com.cnbyte=numbytes;
  if (bf.ibf[0]!=bf.tbf[0]) return(ERROR_TYPEREC);
  if (strncmp((char *)bf.ibf,"$PASHR,RID,\0",11)) return(ERROR_TYPEREC);

  if (com.cnbyte<32)
  { for (i=com.cnbyte;i<32;i++) bf.ibf[i]='_';
    bf.ibf[i]='\0';
    com.cnbyte=32;
  }
  i=com.cnbyte-10;
  memmove(&bf.ibf[1],&bf.ibf[11],i);
  bf.ibf[0]='\x06';

  Identification_Receiver();
	if (rec_type_code==VISPA) return(TRANS_OK);
  if (rec_type_code==LCS_XII) rtf.old_mben_mode=1; else rtf.old_mben_mode=0;

  // for B-file:
  // rawheader ----------------------------------------------------
  BfileRawhead();

  return(TRANS_OK);
}}


void RdRtime::Init_almanac_strct()
{{
  short i;

  for (i=0;i<32;i++)
  { alm[i].e=alm[i].i0=alm[i].omegadot=alm[i].af0=alm[i].af1=0.0;
    alm[i].toe=alm[i].tow=0L;
    alm[i].health=alm[i].wna=alm[i].config=0;
    alm[i].wn=-1;
    alm[i].bulhealth=16128;
    alm[i].roota=alm[i].omega0=alm[i].omega=alm[i].m0=0.0;
  }
  rtf.f_wr_almGPS=0;
  rtc.GPS_alm=0;

  rtt.alm_wn=-1;
  rtt.alm_tow=0L;
	rdd.percent=0.0;
}}

