///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#ifndef __RDRTIME_HPP
#define __RDRTIME_HPP

#ifndef __TRANS_HPP
#include "trans.hpp"
#endif

enum { YREC=0, BHDR, BRX00X09, WHX00X16, WRDT, EREC, AREC, MREC, DRC_,
			 NO_TYPE_HEADER=-1	
		 };
 
const long idf_header_Ufile[9] =
{
  1128616537L,  // YREC
  1380206658L,	// BHDR
  151016002L,		// BR\X00\x09
  369117271L,		// WH\X00\x16
  1413763671L,	// WRDT		
  1128616517L,  // EREC
  1128616513L,	// AREC
  1128616525L,	// MREC
  541282884L,		// DRC' '
};

struct memory_count
{ unsigned long  num_blocks;
  unsigned long  sum_blocks;
  unsigned short index_MBN_PBN;
  unsigned char  f_almanac_time;
};

struct real_time_count
{ unsigned short num_com;

  unsigned long  epoch;
  unsigned long  snav;
  unsigned long  error_epoch;
  unsigned long  error_mc;
  unsigned short GPS_alm;
  unsigned short GLN_alm;

  unsigned short last_count_mben;
  unsigned short count_mben;
  unsigned short num_mben;

  unsigned short num_reiter;
  unsigned short nofull_readblock;
  
  unsigned long  index_Bfile;
  unsigned long  index_Efile;

  unsigned short index_bufBfile;
  unsigned short index_static_buf;
  unsigned short len_static_buf;
  unsigned short beg_buf;
  unsigned short num_VIBF_SIZE;
};

struct real_time_feature
{ char   real_time_mode;
  char   old_mben_mode;

  unsigned char f_wr_Bfile;

  unsigned char f_wr_almGPS;

  unsigned char beg_openBfile;
  unsigned char beg_openEfile;
  unsigned char beg_SNV_data;
};

struct real_time_time
{ double        difGMT;
  short         alm_wn;
  long          alm_tow;
  long          alm_Na;
  short         ion_wn;
  unsigned long ion_tow;
  long          day_year_stime;
};

class RdRtime : public Trans
{
  public:

    RdRtime();

    short ansReceiverInfo(unsigned short numbytes);
    short AlmanacNameFile();
    void  Init_almanac_strct();
    
    unsigned char buf_block[518];
    short         len_almanac;

    // for GG-receivers
    short AnalysDataBlocks(); 
		short EndReadFile(short error);

    // for MicroZ receiver
    short ans_FileDirCountMZ(const char *ansFirstNext);
    short AvailabilityDownloadFile(const unsigned char *varrawfile_name);
    void  InitHeadYFile();
    void  InitforReadVWfile();
		void  CloseReadVWfile();
		short ReadBlocksUfile(const char* _pathVWfile);
    
    unsigned long GetCurrbytesRawfiles() { return(curr_bytes); }
              
    unsigned long rawsession_bytes;
    
	  
  protected:
    //for MZ
    void  Init_varrawfile_name();
    void  Set_varrawfile_name(short index_file);
    void  FillInitCurrSession();
    void  FillSession();
    short ControlReceiverFileName();
    short ControlSession();
		void 	ReadfromYstrct(unsigned short &_i_head);
		void 	Identification_data_type();
		short	Read_data_fromRawfile();                
		short GetYbody();
		short GetHeaderBfile();
		short Read_ALMstrct();
		short GetPhotoData();
		short CompLengthEvent();
		short GetEventData();
    short CurrAlmanacName();

    unsigned long curr_bytes; 
    FILE          *fVWfile;
    char 					pathVWfile[100]; // curr V-file.
    unsigned long rawfile_length;                    
    char 					filedir_name[13];

		memory_count			vmem;	

    real_time_count   rtc;
    real_time_feature rtf;
    real_time_time    rtt;


		char header_buf[15];
};
#endif
