#!/usr/bin/perl
#    Ashtech remote receiver access tools
#    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    FILE:        exec.pl
#
#    DESCRIPTION: This PERL script serves as the shell for another scripts
#             
#
#    $Log: exec.pl,v $
#    Revision 1.1  1999/10/14 00:48:44  serg
#    Just new files.
#
#
#############################################################################

require "ash-lib.pl";  # This library contains some useful subroutines
                      

if ($#ARGV  < 0 ) {
  print STDERR "Configuration file name must be specified\n";
  exit 1;
}

# Get the configuration

print STDERR "Get configuration\n";

$ConfigFile  = $ARGV[0];
$ScriptName  = ReadVar($ConfigFile,"ScriptName","");
$ScriptDir   = ReadVar($ConfigFile,"ScriptDir",".");
$RootDataDir = ReadVar($ConfigFile,"DataDir",".");
$Port        = ReadVar($ConfigFile,"Port","/dev/ttyS0");
$MailList    = ReadVar($ConfigFile,"MailList","");

#
# Change the directory 
#

print STDERR "Set working directory\n";

my ($sec,$min,$hour,$mday,$mon,$year) = localtime();

$DirBaseName = sprintf("%s%02d%02d%02d.",($RootDataDir . "/" , $mon+1 ,$mday ,  $year . ".") );

CREATE_DATA_DIR: for (0...999) {
    $DataDir = $DirBaseName . sprintf("%03d/",$_);
    last CREATE_DATA_DIR if mkdir ( $DataDir ,0777 ) ;
}

chdir $DataDir or die "Can not change directry to $DataDir\n";
print STDERR "Directory: $DataDir\n";

#
# Some local variables
#
$LogName      = "fulllog.txt";
$LogFile      = $DataDir . "/" . $LogName;
$ReportFile   = $DataDir . "/mail.txt";

#
# Run script
#

if ( $MailList ne "" )
{
    $ErrorOutput = " 2>$LogFile";
}
else
{
    $ErrorOutput = "";
}


if ( $ScriptName ne "" )
{
    $ScriptName = $ScriptDir . "/" . $ScriptName;
    $Args = $ConfigFile ." " . " " . $ReportFile ; 
    $Command = "perl -I $ScriptDir $ScriptName $Args < $Port > $Port " . $ErrorOutput;
    print STDERR ">$Command\n";
    system $Command;
}
else
{
    print STDERR "No script to run was specified in config file.\n";
    print STDERR "Is that what you wanted ?\n";
}

#
# Send email
#

if ( $MailList ne "" )
{
  # UUENCODE the attachment
  $UuEncodedFile = $DataDir . "/fulllog.uue";
  $Command = "uuencode $LogFile $LogName > $UuEncodedFile";
  print STDERR ">$Command\n";
  system $Command;

  $Title  = ReadVar($ConfigFile,"Title","No title specified") . " at  $Port ";
  $Title  = ' " ' . $Title  .  ' "';  # Put title to double qoutes

  # Send e-mail
  $Command = "cat $ReportFile $UuEncodedFile | mail $MailList -s $Title"; 
  print STDERR ">$Command\n";
  system $Command;
}









